import { DATASET_STATES } from "@/config"
import { UUID, ElementList } from "@/types"

export type DatasetState = keyof typeof DATASET_STATES

export interface Dataset {
  id: UUID
  state: DatasetState
  name: string
  description: string
  sets: string[]
}

export interface DatasetDetails extends Dataset {
  corpus_id: UUID
  creator: string
  task_id: UUID
  created: string
  updated: string
}

export function isDatasetDetails(dataset: Dataset): dataset is DatasetDetails {
  return (
    'corpus_id' in dataset && typeof dataset.corpus_id == "string"
    && 'creator' in dataset && typeof dataset.creator == "string"
    && 'task_id' in dataset && (dataset.task_id === null || typeof dataset.task_id == "string")
    && 'created' in dataset && typeof dataset.created == "string"
    && 'updated' in dataset && typeof dataset.updated == "string"
  )
}

export interface DatasetElementList {
  set: string,
  element: ElementList
}

export interface ElementDataset {
  dataset_id: UUID
  dataset_name: string
  set: string
}
