import { ModelVersionState } from '@/enums'
import { Right, UUID } from '.'

export interface ModelLight {
  id: UUID
  name: string
}

export interface ModelVersionLight {
  id: UUID
  model: ModelLight
  tag: string | null
  state: ModelVersionState
  size: number
  configuration: object
}

export interface Model {
  id: UUID
  name: string
  created: string
  updated: string
  description: string
  rights: Right[]
}

export interface ModelVersion {
  id: UUID
  model_id: UUID
  created: string
  parent: UUID | null
  description: string
  tag: string | null
  state: ModelVersionState
  size: number
  hash: string
  configuration: Record<string, unknown>
  s3_url: string | null
  s3_put_url: string | null
}
